<?php
/* ReplayCharge v1.16
 *
 * Plugin by Leigham. With thanks to Xymph, from whom I stole some code :)
 *
 * Important: This plugin will only work on a TMUF server. 
 * The server must have at least a small amount of coppers for
 * the plugin to work.
 *
 * Scroll down to configure plugin settings.
 */

Aseco::registerEvent('onSync',                      'replaychargeVersion');
Aseco::registerEvent('onStartup',                   'replaychargeSetup');
Aseco::registerEvent('onPlayerConnect',             'replaychargeConnect');
Aseco::registerEvent('onNewChallenge',              'replaychargeOn');
Aseco::registerEvent('onEndRace',                   'replaychargeOff');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'replaychargeClick');
Aseco::registerEvent('onBillUpdated',               'replaychargeBill');

function replaychargeVersion($aseco) { // Register this to the global version pool (for up-to-date checks)
  $aseco->plugin_versions[] = array(
     'plugin'   => 'plugin.replaycharge.php',
     'author'   => 'Leigham',
     'version'   => '1.16'
  );
}

function replaychargeSetup($aseco) {
	global $position, $coppers, $replaybills;

// Configuration settings below
	if ($config = $aseco->xml_parser->parseXml('replaycharge.xml', true)) {
    $config = $config['SETTINGS'];
    $posx = $config['POSX'][0];
    $posy = $config['POSY'][0];
    $coppers = intval($config['CHARGE'][0]);
		$position = $posx.' '.$posy.' 1';   
		
		$replaybills = array();
		} else {
     // could not parse XML file
     trigger_error('[swearbox] Could not read/parse setttings file swearbox.xml!', E_USER_WARNING);
     return false;
  }
}

function replaychargeConnect($aseco) {
	global $replaytrue;
	
	if (!$replaytrue) {
		replaychargeOn($aseco);
	} else {
		replaychargeSuccess($aseco);
	}
}

function replaychargeOn($aseco) {
	global $position, $coppers, $replaytrue;
	
	$replaytrue = false;
	
	$xml = '<manialink id="1234512301">
    <frame posn="'.$position.'">
        <quad posn="0 0 0" sizen="23 5" style="BgsPlayerCard" substyle="BgCardSystem" action="234561"></quad>
        <label posn="11.3 -2.4 1" sizen="23 5" halign="center" valign="center" textsize="2.5" textcolor="FFFF" text="Replay track for '.$coppers.' coppers!"></label>
    </frame>
	</manialink>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function replaychargeSuccess($aseco) {
	global $position;
	
	$xml = '<manialink id="1234512301">
    <frame posn="'.$position.'">
        <quad posn="0 0 0" sizen="23 5" style="BgsPlayerCard" substyle="BgCardSystem"></quad>
        <label posn="11.3 -2.4 1" sizen="23 5" halign="center" valign="center" textsize="2.5" textcolor="FFFF" text="Track is being replayed!"></label>
    </frame>
	</manialink>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function replaychargeOff($aseco) {
	
	$xml = '<manialink id="1234512301">
		<frame posn="0 0 0">
			<quad posn="0 0 0" sizen="0 0" halign="center" valign="center" action="234561"></quad>
		</frame>
	</manialink>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function replaychargeClick($aseco, $command) {
	global $coppers, $replaybills;
	
	$playerid = $command[0];
	$login = $command[1];
	$answer = $command[2].'';
	$aseco->client->query('GetDetailedPlayerInfo', $login);
	$player = $aseco->client->getResponse();
	$nickname = $player['NickName'];
		if ($answer == '234561') {
		$aseco->client->query('GetCurrentChallengeInfo');
		$thistrack = $aseco->client->getResponse();
		$aseco->client->query('GetNextChallengeInfo');
		$nexttrack = $aseco->client->getResponse();
		// Check if already being replayed
		if ($thistrack['FileName'] != $nexttrack['FileName']) {	
			//	Check for TMF server
			if ($aseco->server->getGame() == 'TMF') {
				// check for TMUF server
				if ($aseco->server->rights) {
					// check for TMUF player
					if ($player['OnlineRights'] == 3) {
						// start the transaction
						$message = 'You need to pay '.$coppers.' coppers to replay the track';
						$aseco->client->query('SendBill', $login, $coppers, $message, '');
						$replaybillid = $aseco->client->getResponse();
						$replaybills[$replaybillid] = array($login, $nickname, $coppers);
					} else {
					$message = formatText($aseco->getChatMessage('UNITED_ONLY'), 'account');
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
					}
				} else {
				$message = formatText($aseco->getChatMessage('UNITED_ONLY'), 'server');
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				}
			} else {
			$message = $aseco->getChatMessage('FOREVER_ONLY');
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
			}
		} else {
		$message = '>$f00 This track is already being replayed';
		$aseco->client->query('ChatSendServerMessageToLogin', $message, $login);
		}
	}
}
		// [0]=BillId, [1]=State, [2]=StateName, [3]=TransactionId
function replaychargeBill($aseco, $replaybill) {
	global $replaybills, $jukebox, $replaytrue;
	$replaybillid = $replaybill[0];
	// check for known bill ID
	if (array_key_exists($replaybillid, $replaybills)) {
		// get bill info
		$login = $replaybills[$replaybillid][0];
		$nickname = $replaybills[$replaybillid][1];
		$coppers = $replaybills[$replaybillid][2];
				// check bill state
		switch($replaybill[1]) {
		case 4:  // Payed (Paid)
			$uid = $aseco->server->challenge->uid;
			$jukebox = array_reverse($jukebox, true);
			$jukebox[$uid]['FileName'] = $aseco->server->challenge->filename;
			$jukebox[$uid]['Name'] = $aseco->server->challenge->name;
			$jukebox[$uid]['Env'] = $aseco->server->challenge->environment;
			$jukebox[$uid]['Login'] = $login;
			$jukebox[$uid]['Nick'] = $nickname;
			$jukebox[$uid]['source'] = 'ReplayCharge';
			$jukebox[$uid]['tmx'] = false;
			$jukebox[$uid]['uid'] = $uid;
			$jukebox = array_reverse($jukebox, true);
			
			$aseco->releaseEvent('onJukeboxChanged', array('replay', $jukebox[$uid]));
			$message = '$f90Player $z'.$nickname.'$z$f90  pays '.$coppers.' coppers and queues challenge for replay!';
			$aseco->client->query('ChatSendServerMessage', $message);
			$aseco->console('Player {1} paid {2} coppers to replay the current track', $login, $coppers);
			unset($replaybills[$replaybillid]);
			$replaytrue = true;
			replaychargeSuccess($aseco);
			break;
		case 5:  // Refused
			$message = '{#server}> {#error}Transaction refused!';
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
			unset($replaybills[$replaybillid]);
			break;
		case 6:  // Error
			$message = '{#server}> {#error}Transaction failed: {#highlite}$i ' . $replaybill[2];
			if ($login != '')
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
			else
				$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
			unset($replaybills[$replaybillid]);
			break;
		default:  // CreatingTransaction/Issued/ValidatingPay(e)ment
			break;
		}
	}
}
?>